// JawEx4.java

import ch.aplu.util.*;
import ch.aplu.jaw.*;

public class JawEx4 implements ExitListener
{
  private int evt;
  private int x;
  private int y;
  private NativeHandler nh;
  
  public JawEx4()
  {
    Console c = new Console();
    c.addExitListener(this);
    nh = new NativeHandler(
      "s:\\myjni\\mouseevent\\release\\mouseevent.dll",
      this,
      "Move Window",
      10, 20,
      258, 184, 
      NativeHandler.WS_POPUP | NativeHandler.WS_VISIBLE);
    
    System.out.println(
      "Click or drag image with left mouse button");
    while (true)
    {
      Monitor.putSleep(); 
      displayEvent();
    }
  }

  // Native call
  private void mouseEvent(int evt, int x, int y)
  {
    this.evt = evt;
    this.x = x;
    this.y = y;
    Monitor.wakeUp();
  }
  
  // Implement ExitListener
  public void notifyExit()
  {
    nh.destroy();
    System.exit(0);
  }

  private void displayEvent()
  {
    switch (evt)
    {
      case NativeMouse.lPress:
        report("LeftButtonDown", x, y);
        break;

      case NativeMouse.lRelease:
        report("LeftButtonUp", x, y);
        break;

      case NativeMouse.lDClick:
        report("LeftButtonDoubleClick", x, y);
        break;
    }
  }

  private void report(String msg, int x, int y)
  {
    System.out.println(
      msg + " at x: " + x + " y: " + y);
  }
    
  public static void main(String args[])
  {
    new JawEx4();
  }
}

