// AudioHandler.cpp
// Project properties: Add irrKlang include directory
//                     Add library irrKlang.lib
// irrKlang.dll and ikpMP3.dll must reside in the
// Java class home directory

#include "AudioHandler.h"

// ----------------- Selector  -------------------------------
WindowHandler * 
  selectWindowHandler(JNIEnv * env, jobject obj, int select)
{
  return new AudioHandler(env, obj);
}

// ----------------- class AudioHandler ----------------------
int AudioHandler::invoke(int val)
{
  // Get string from Java instance variable
  audiofile = JNIString(_exposedObj, "audiofile").getMBCS();

	// Start the sound engine with default parameters
	engine = createIrrKlangDevice();

	if (!engine)
   return -1; // Error starting the engine
	return 0;
}

bool AudioHandler::wantThreadMsg(UINT uMsg)
{
   return (uMsg == WM_THREADSTART || WM_THREADSTOP);
}

void AudioHandler::evThreadMsg(HWND /*hwnd*/, 
							   UINT message, 
							   WPARAM /* wParam */, 
							   LPARAM /* lParam */)
// Runs in the high priority native JNIThread
{
  switch (message)
  {
    case WM_THREADSTART:
	    engine->play2D(audiofile);
      break;

    case WM_THREADSTOP:
      engine->drop(); // Delete engine
	    delete [] audiofile;  // Release allocated memory
      break;
  }
}
