// DataHandler.cpp

#include "DataHandler.h"
#include <iostream>

using namespace std;

// ----------------- Selector  -------------------------------
WindowHandler * 
  selectWindowHandler(JNIEnv * env, jobject obj, int select)
{
   return new DataDemo(env, obj);
}

// ----------------- class DataDemo --------------------------
int DataDemo::invoke(int val)
{
  switch (val)
  {
    case 0:
    {
      const char * charstr = 
        JNIString(_exposedObj, "str").getMBCS();
      cout << "C++ got MBCS string: " << charstr << endl;
      delete[] charstr;  // Release memory

      const char * utf8str = 
        JNIString(_exposedObj, "str").getUTF8();
      cout << "C++ got UTF8 string: " << utf8str << endl;
      delete[] utf8str;  // Release memory

      const wchar_t * unicodestr = 
        JNIString(_exposedObj, "str").getUnicode();
      int len = int(wcslen(unicodestr));
      char * asciistr = new char[len + 1];
      WideCharToMultiByte(CP_ACP, 0, unicodestr, -1, 
                          asciistr, len+1, NULL, NULL);
      cout << "C++ got unicode string: " << asciistr << endl;
      delete[] unicodestr;  // Release memory
      delete[] asciistr;    // ditto
    }
    break;

    case 1:
      {
        const char * cstr = "ABC-";
        JNIString(_exposedObj, "str").setUTF8(cstr);
      }
      break;
      
    case 2:
      {
        const char * cstr = "ABC-";
        JNIString(_exposedObj, "str").setMBCS(cstr);
      }
      break;

    case 3:
      {
        // Don't forget prefix L
        const wchar_t * unicodeStr = L"ABC-"; 
        JNIString(_exposedObj, "str").setUnicode(unicodeStr);
      }
      break;

    case 4:
    {
      JNIArray<int> jary(_exposedObj, "ary");
      int * ary = jary.get();
      cout << "C++ got array:" << endl;
      for (int i = 0; i < 3; i++)
         cout << (int)ary[i] << ", ";
      cout << endl;

      // Write new values back to Java
      for (int i = 0; i < 3; i++)
        ary[i] = 10*(i+1);

      // JNIArray<> destructor releases array here
      break;
    }
  }
  return 0;
}
