// NIDAQHandler.h

#ifndef __NIDAQHandler_h__
#define __NIDAQHandler_h__

#include "NIDAQmxBase.h"
#include "jaw.h"

// ---------------- class NIDAQAcquire1Scan --------------
class NIDAQAcquire1Scan : public WindowHandler
{
public:
  NIDAQAcquire1Scan(JNIEnv * env, jobject obj);
  ~NIDAQAcquire1Scan();

private:
  int invoke(int tag);
  int period;

  // Task parameters
  int32	      error;
  TaskHandle  taskHandle;
  char        errBuff[2048];

  // Channel parameters
  const char* chan;
  float64     min;
  float64     max;

  // Timing parameters
  uInt32      samplesPerChan;

  // Data read parameters
  float64     data;
  int32       pointsToRead;
  int32       pointsRead;
  float64     timeout;
};

#endif

