// NIDAQHandler.h

#ifndef __NIDAQHandler_h__
#define __NIDAQHandler_h__

#include "NIDAQmxBase.h"
#include "jaw.h"

// ---------------- class NIDAQContAcquireNScan --------------
class NIDAQContAcquireNScan : public WindowHandler
{
public:
   NIDAQContAcquireNScan(JNIEnv * env, jobject obj);
   ~NIDAQContAcquireNScan();

private:
   int invoke(int tag);

   // Task parameters
   int32       error;
   TaskHandle  taskHandle;
   char        errBuff[2048];
   int32       i;

   // Channel parameters
   const char* chan;
   float64     min;
   float64     max;

   // Timing parameters
   char        clockSource[128];
   uInt64      samplesPerChan;
   float64     sampleRate;

   // Data read parameters
   int32       pointsToRead;
   int32       pointsRead;
   float64     timeout;
};


#endif

