// TransHandler.cpp

#include "TransHandler.h"
#include <windows.h>

// ----------------- Selector --------------------------------
WindowHandler * 
  selectWindowHandler(JNIEnv * env, jobject obj, int select)
{
  return new TransHandler(env, obj);
}

// ----------------- class TransHandler  ---------------------
// Constructor, initialize base class
TransHandler::TransHandler(JNIEnv * env, jobject obj)
  : WindowHandler(env, obj)
{
}

// Select which window messages will call evMsg()
bool TransHandler::wantMsg(UINT uMsg)
{
  return (uMsg == WM_CREATE ||
	                WM_PAINT ||
				          WM_DESTROY);
}

// Event procedure
// Return false, if message is handled by this procedure, 
// true to invoke DefWindowProc()
bool TransHandler::evMsg(HWND hWnd, UINT message, 
                         WPARAM /* wParam */, LPARAM lParam)
{
  static HBITMAP hBm = NULL;
  HDC hDC;
  HDC hDCMem;
  BITMAP bm;
  PAINTSTRUCT ps;

  switch (message)
  {
    case WM_CREATE:
      hBm = LoadBitmap(getInstance(), TEXT("ROSE"));
      break;

    case WM_PAINT:
      hDC = BeginPaint(hWnd, &ps);
      hDCMem = CreateCompatibleDC(hDC);
      SelectObject(hDCMem, hBm);
      GetObject(hBm, sizeof(bm), &bm);
      BitBlt(hDC, 0, 0, bm.bmWidth, bm.bmHeight, 
             hDCMem, 0, 0, SRCCOPY);
      DeleteDC(hDCMem);
      EndPaint(hWnd, &ps);
	  return false;

    case WM_DESTROY:
      DeleteObject(hBm) ;
      break;
  }
  return true;
}
