// JniEx4.java

import java.util.*;
import ch.aplu.util.*;

public class JniEx4
{
  // Inner class
  private class StatusThread extends Thread
  {
    String msg = "Suche Anzahl Primzahlen im Bereich\n" +
                 start + " und " + end +
                 "\nBitte warten...";
  
    public void run()
    {
      mop.setText(msg);
      long startTime = new Date().getTime();
      while (isRunning)
      {
        int elapsed = (int)((new Date().getTime() - startTime)/1000.0);
        mop.showTitle("Rechenzeit: " + elapsed + " s");
        Console.delay(1000);  
      }
    }
  }
  
  // Native method
  private native void getNbPrimes();

  // Instance variables used by native code
  private long start = 1000000000000000L; // 10^15
  private long end   = 1000000000000200L;
  
  // Instance variables
  private volatile boolean isRunning = true;
  private ModelessOptionPane mop = new ModelessOptionPane("");
  private StatusThread statusThread;
  
  // Constructor
  public JniEx4()
  {
    System.load("s:\\myjni\\callback\\release\\callback.dll");
    statusThread = new StatusThread();
    statusThread.start();
    getNbPrimes();
  }

  // Callback method invoked by native code
  private void notify(int nbPrimes)
  {
    isRunning = false;
    mop.setText("Anzahl gefundener Primzahlen: " + nbPrimes);
  }  
  
  public static void main(String args[])
  {
    new JniEx4();
  }
}
