// callback.cpp

#include <jni.h>
#include <iostream>
#include <windows.h>
#include "JniEx4.h"

using namespace std;

// Prototype
bool isPrime(__int64 n);

JNIEXPORT void JNICALL 
Java_JniEx4_getNbPrimes(JNIEnv * env, jobject obj)
{
  __int64 start;
  __int64 end;

  // Get class instance
  jclass clazz = env->GetObjectClass(obj);

  // Get field IDs
  jfieldID startID = env->GetFieldID(clazz, "start", "J");
  jfieldID endID = env->GetFieldID(clazz, "end", "J");

  // Read variables and cast to c-type
  start = (__int64)env->GetLongField(obj, startID);
  end = (__int64)env->GetLongField(obj, endID);

  cout << "start: " << start << endl;
  cout << "end: " << end << endl;
  int nbPrimes = 0;
  for (__int64 i = start; i < end; i++)
  {
   if (isPrime(i))
    nbPrimes++;
   Sleep(1);  // Improve performance for other threads
  }
  cout << "nb of primes: " << nbPrimes << endl;

  // Get method ID
  jmethodID notifyID = env->GetMethodID(clazz, "notify", "(I)V");

  // Invoke Java method
  env->CallVoidMethod(obj, notifyID, nbPrimes);
}

bool isPrime(__int64 n)
{
  for (__int64 i = 2; i * i <= n; i++)
  {
    if (n % i == 0)
      return false;
  }
  return true;
}