// inc.cpp

#include <jni.h>
#include "JniEx3.h"

JNIEXPORT void JNICALL 
Java_JniEx3_increase(JNIEnv * env, jobject obj)
{
  int _n;
  double _x;

  // Get class instance
  jclass clazz = env->GetObjectClass(obj);

  // Get field IDs
  jfieldID n_ID = env->GetFieldID(clazz, "n", "I");
  jfieldID x_ID = env->GetFieldID(clazz, "x", "D");

  // Read variables and cast to c-type
  _n = (int)env->GetIntField(obj, n_ID);
  _x = (double)env->GetDoubleField(obj, x_ID);

  // Perform operation
  _n++;
  _x++;

  // Cast to jni-type and write back to Java
  env->SetIntField(obj, n_ID, (jint)_n);
  env->SetDoubleField(obj, x_ID, (jdouble)_x);
}

