// reg.cpp

#include <windows.h>
#include <jni.h>
#include "JniEx2.h"

HKEY keyHandle;

JNIEXPORT jboolean JNICALL 
Java_JniEx2_openKey(JNIEnv * env, jobject, jstring key)
{
  // Convert Java string to C string
  const char * c_key = env->GetStringUTFChars(key, 0);

  long rc = 
    RegOpenKey(HKEY_LOCAL_MACHINE, c_key, &keyHandle);

  // Release memory used to hold ASCII representation
  env->ReleaseStringUTFChars(key, c_key);

  // Return true if success, false if error
  return (rc == ERROR_SUCCESS) ? true : false;
}

JNIEXPORT jstring JNICALL 
Java_JniEx2_queryValue(JNIEnv * env, jobject, 
                       jstring valueName)
{
  unsigned char buf[200];
  DWORD bufsize = sizeof(buf);
  DWORD type;

  // Convert Java string to C string
  const char * c_valueName = 
    env->GetStringUTFChars(valueName, 0);

  long rc = 
    RegQueryValueExA(keyHandle, c_valueName, NULL, &type, 
	                 buf, &bufsize);

  // Release memory used to hold ASCII representation
  env->ReleaseStringUTFChars(valueName, c_valueName);

  // Return converted C string or null, if error
  return (rc == ERROR_SUCCESS) ? 
    env->NewStringUTF((const char *)buf) : 0;
}

JNIEXPORT void JNICALL 
Java_JniEx2_closeKey(JNIEnv *, jobject)
{
  RegCloseKey(keyHandle);
}
