// MySoundConverter.java
// soundtouch.dll must reside in class directory
// or in system's search path, e.g. in c:\windows\system32

import javax.sound.sampled.*;
import ch.aplu.jaw.*;
import ch.aplu.util.*;

class MySoundConverter extends SoundTouch implements SoundConverter
{
  private float totalPitchDelta;
  private float totalTempoDelta;
  private boolean doUpdate = false;

  MySoundConverter(AudioFormat audioFormat)
  {
    int sampleRate = (int)audioFormat.getSampleRate();
    int nbChannels = audioFormat.getChannels();
    int frameSize = audioFormat.getFrameSize();

    setSampleRate(sampleRate);
    setChannels(nbChannels);
  }

  void setParams(float totalPitchDelta, float totalTempoDelta)
  {
    this.totalPitchDelta = totalPitchDelta;
    this.totalTempoDelta = totalTempoDelta;
    doUpdate = true;
  }


  // ---------- Implementation of methods in interface SoundConverter --------
  public void putSamples(byte[] inBuffer, int numBytes)
  {
    super.putSamples(inBuffer, numBytes);
  }

  public int receiveSamples(byte[] outBuffer, int maxBytes)
  {
    return super.receiveSamples(outBuffer, maxBytes);
  }

  public void update()
  {
    if (doUpdate)
    {
      setPitchSemiTones(totalPitchDelta);
      setTempoChange(totalTempoDelta);
      doUpdate = false;
    }
  }

  public void cleanup()
  {
    flush();
  }
}
