// JNIArray.h

#ifndef __jniarray_h__
#define __jniarray_h__

#include <jni.h>
#include <typeinfo.h>
#include "WindowThread.h"

#ifndef SHOW_ERROR
#define SHOW_ERROR(title, msg) \
   MessageBox(HWND_DESKTOP, msg, title, MB_ICONEXCLAMATION | MB_OK);
#endif

template <typename T>
class JNIArray 
{
public:
  JNIArray(jobject jObject, const char * name);
  ~JNIArray();
  T * get();
  void release();

private:
   jfieldID getFieldID();
   JNIEnv * _env;
   jobject _jObject;
   char * _pName;
   char _type[100];
   jfieldID _id;
   jboolean _isCopy;
   jcharArray _charAry;
   jbooleanArray _booleanAry;
   jbyteArray _byteAry;
   jshortArray _shortAry;
   jintArray _intAry;
   jlongArray _longAry;
   jfloatArray _floatAry;
   jdoubleArray _doubleAry;
   jchar * _charArrayElements;
   jboolean * _booleanArrayElements;
   jbyte * _byteArrayElements;
   jshort * _shortArrayElements;
   jint * _intArrayElements;
   jlong * _longArrayElements;
   jfloat * _floatArrayElements;
   jdouble * _doubleArrayElements;
   bool _isAttached;
};

#endif
