
#ifndef __jnibuffer_h__
#define __jnibuffer_h__

#include "jniarray.h"
#include "jnivar.h"

#ifndef min
#define min(x,y) ((x) > (y) ? (y) : (x))
#endif

#ifndef SHOW_ERROR
#define SHOW_ERROR(title, msg) \
   MessageBox(HWND_DESKTOP, msg, title, MB_ICONEXCLAMATION | MB_OK);
#endif

template <typename T>
class JNIBuffer
{
public:
   JNIBuffer(JNIEnv * env, T jary, jint bufSize);
   virtual ~JNIBuffer();
   void write(bool value);
   void write(wchar_t value);
   void write(signed char value);
   void write(short value);
   void write(int value);
   void write(__int64 value);
   void write(float value);
   void write(double value);
   int read(int count);
   int count();
   void flush();
   bool isOverflow(bool reset);

private:
   JNIEnv * _myEnv;
   T _myAry;
   void iniArray();
   void copyBuf(T jary, int start, int count, int offset);
   bool * _pBoolAry;
   wchar_t * _pCharAry;
   signed char * _pByteAry;
   short * _pShortAry;
   int * _pIntAry;
   __int64 * _pLongAry;
   float * _pFloatAry;
   double * _pDoubleAry;
   char _type;
   int _bufSize;
   jint _arySize;
   int _tail;  // Index of first element to write
   int _head;  // Index of first element to retrieve
   int _nb;    // Number of valid elements
   bool _overflow;  // Error condition
};


#endif
