// JNIMethod.h

#ifndef __jnimethod_h__
#define __jnimethod_h__

#ifndef SHOW_ERROR
#define SHOW_ERROR(title, msg) \
   MessageBox(HWND_DESKTOP, msg, title, MB_ICONEXCLAMATION | MB_OK);
#endif

template <typename T>
class JNIMethod 
{

public:
   JNIMethod(jobject jObject, const char * name);
   JNIMethod(jobject jObject, const char * name, const char * parSig);
   ~JNIMethod();
   T call();
   T call(jvalue * params);

private:
   void init(jobject jObject, const char * name, const char * parSig);
   jmethodID getMethodID();
   JNIEnv * _env;
   jobject _jObject;
   char * _pName;
   char * _pParSig;
   char _type[2];
   jmethodID _mid;
};

#endif


