// JNIString.cpp

#ifndef __JNIString_h__
#define __JNIString_h__

#include <jni.h>

#ifndef SHOW_ERROR
#define SHOW_ERROR(title, msg) \
   MessageBox(HWND_DESKTOP, msg, title, MB_ICONEXCLAMATION | MB_OK);
#endif

class JNIString {

public:
  JNIString(jobject jObject, const char * name);
  ~JNIString();
  const wchar_t * getUnicode();
  const char * getMBCS(); // Multi-Byte Character Set
  const char * getUTF8();
  void setUnicode(const wchar_t * value);
  void setMBCS(const char * value);
  void setUTF8(const char * value);

  static const wchar_t * getUnicode(JNIEnv * env, jstring jstr);
  static const char * getMBCS(JNIEnv * env, jstring jstr); // Multi-Byte Character Set
  static const char * getUTF8(JNIEnv * env, jstring jstr);

private:
   jfieldID getFieldID();
   JNIEnv * _env;
   jobject _jObject;
   char * _pName;
   char _type[100];
   jfieldID _id;
};

#endif
