#ifndef __jnivar_h__
#define __jnivar_h__

#include <jni.h>
#include <typeinfo.h>
#include "WindowThread.h"
#include <tchar.h>

#ifndef SHOW_ERROR
#define SHOW_ERROR(title, msg) \
   MessageBox(HWND_DESKTOP, title, msg, MB_ICONEXCLAMATION | MB_OK);
#endif

template <typename T>
class JNIVar 
{

public:
  JNIVar(jobject jObject, const char * name);
  ~JNIVar();
  T get();
  void set(T value);
  void call(const char * func);

private:
   jfieldID getFieldID();
   JNIEnv * _env;
   jobject _jObject;
   char * _pName;
   char _type[100];
   jfieldID _id;
};

#endif
