// WindowList.h

#ifndef __WindowList_h__
#define __WindowList_h__

#include <windows.h>
#include <jni.h>
#include "WindowHandler.h"

// ------------------ class WindowListItem ---------------------------
class WindowListItem
{
friend class WindowList;

public:
   WindowListItem::WindowListItem(); // Default ctor
   WindowListItem::WindowListItem(HWND hwnd, jobject jObj, WindowHandler * pHandler); // Ctor

private:
   HWND hWnd;
   jobject jObject;
   WindowHandler * pWh;
};


// ------------------ class WindowList ---------------------------
class WindowList
{
struct ListNode
{
   WindowListItem * pInfo;
   ListNode * pNext;
};

public:
   WindowList::WindowList();  // Ctor
   virtual ~WindowList();  // Dtor
   void insert(HWND hWnd, jobject jObject, WindowHandler * pHandler);
   jobject getObject(HWND hwnd);
   WindowHandler * getHandler(HWND hwnd);
   WindowHandler * getHandler(jobject jObject);
   void remove(HWND hwnd);
   int getSize();


private:
   ListNode * pHead;
   ListNode * pTail;
};


#endif


