// WindowThread.h

#ifndef __WindowThread_h__
#define __WindowThread_h__

#define WM_NativeWindow (WM_USER+9876)
#define WM_THREADSTART (WM_USER+9877)
#define WM_THREADSTOP (WM_USER+9878)
#define WM_TASKBARICON (WM_USER+9879)

#define LPRESS      1
#define LRELEASE    2
#define LCLICK      4
#define LDCLICK     8
#define RPRESS     16
#define RRELEASE   32
#define RCLICK     64
#define RDCLICK   128
#define ENTER     256
#define LEAVE     512
#define MOVE     1024

#include <windows.h>
#include <jni.h>

class WindowList;  // Forward decl

class WindowThread
{
friend class WindowHandler;

public:

   WindowThread(); // Ctor
   virtual ~WindowThread();  // Dtor
   DWORD getThreadId() { return threadId; }
   int getHandlerCount() { return handlerCount; }
   JNIEnv * getEnv() { return jniEnv; }
   void setEnv(JNIEnv * env) { jniEnv = env; }
   WindowList * getWindowList() { return pWindowList; }

private:

   static DWORD WINAPI ThreadProc(LPVOID lpParameter);
   void create(JNIEnv *env);
   DWORD threadId;
   HANDLE hThread;
   JavaVM * pVm;
   JNIEnv * jniEnv;
   JNIEnv * jniThreadEnv;
   WindowList * pWindowList;
   int handlerCount;  // Counts the number of WindowHandlers
                      // not static, because only one WindowThread instance is created
   WindowThread * pThread;
};

extern WindowThread threadInstance; // Thread instance from NativeWindowsThread


#endif
