// JNIThread.cpp

#include "JNIThread.h"
#include "WindowHandler.h"

#ifndef SHOW_ERROR
#define SHOW_ERROR(title, msg) \
   MessageBox(HWND_DESKTOP, msg, title, MB_ICONEXCLAMATION | MB_OK);
#endif


JNIThread::JNIThread(WindowHandler * pWindowHandler, int priority)
{
   _hThread = CreateThread
   (
      NULL,       // Pointer to thread security attribute
      0,          // Stack size, 0: same as calling process stack
      ThreadProc, // Thread event procedure
      pWindowHandler, // Value passed to thread's event procedure
      0,              // Creation flag
      &_threadId   // Thread identifier
    );
    
    SetThreadPriority(_hThread, priority);
//	cout << "Thread created: " << (int)_hThread << endl;
}

DWORD WINAPI JNIThread::ThreadProc(LPVOID lpParameter)
{
	WindowHandler * pThis = (WindowHandler *)lpParameter;

//   DWORD tId = GetCurrentThreadId();
//   cout << "ThreadId: " << tId << " pThis: " << (int)pThis <<  endl;

   MSG msg;
   while (GetMessage(&msg, NULL, 0, 0))
   {
     //      cout << "Message hex " << hex << msg.message << endl;
       if (msg.message == WM_NativeWindow)
	   {
          switch (msg.wParam)
		  {
            case WindowHandler::enableCode:
//                cout << "Thread will be enabled..." << endl;
           	    if (pThis && pThis->wantThreadMsg(WM_THREADSTART))
                   pThis->evThreadMsg(msg.hwnd, WM_THREADSTART, msg.wParam, msg.lParam);
				break;

			case WindowHandler::suspendCode:
//                cout << "Thread will be suspended..." << endl;
           	    if (pThis && pThis->wantThreadMsg(WM_THREADSTOP))
                   pThis->evThreadMsg(msg.hwnd, WM_THREADSTOP, msg.wParam, msg.lParam);
				break;

			case WindowHandler::disableCode:
//                cout << "Thread will die now..." << endl;
           	    if (pThis && pThis->wantThreadMsg(WM_THREADSTOP))
                   pThis->evThreadMsg(msg.hwnd, WM_THREADSTOP, msg.wParam, msg.lParam);
				ExitThread(0);
				break;
		  }
	   }
	   else
	   {
   	      if (pThis && pThis->wantThreadMsg(msg.message))
             pThis->evThreadMsg(msg.hwnd, msg.message, msg.wParam, msg.lParam);

          TranslateMessage(&msg);
          DispatchMessage(&msg);
	   }
   }
   return 0;
}

